                     PROGRAM
                     MAP
                     END

cmControlWidth       EQUATE(18)
cmControlHeight      EQUATE(12)
cmControlXOffset     EQUATE(3)
cmControlYOffset     EQUATE(3)

CalendarManager      CLASS,TYPE
Window                 &Window,PRIVATE
Region                 LONG,PRIVATE
Year                   &LONG,PRIVATE
Month                  &LONG,PRIVATE
pYear                  LONG,PRIVATE
pMonth                 LONG,PRIVATE
Result                 &LONG,PRIVATE
ResultStr              &STRING,PRIVATE
Days                   LONG,DIM(31),PRIVATE
FirstEntry             LONG,PRIVATE
FirstPrompt            LONG,PRIVATE
FirstHeader            LONG,PRIVATE
Follow                 LONG,PRIVATE

Init                   PROCEDURE(WINDOW lWindow, LONG Region, LONG Follow, *LONG lYear, *LONG lMonth, *LONG lResult, *STRING lResultStr)
TakeEvent              PROCEDURE
GetResult              PROCEDURE(),LONG
SetAll                 PROCEDURE(BYTE Hours)
Kill                   PROCEDURE

PrepareDays            PROCEDURE,PRIVATE
BuildControls          PROCEDURE,PRIVATE
Update                 PROCEDURE,PRIVATE
                     END

CM                   CalendarManager

loc:Year             LONG
loc:Month            LONG
loc:Result           LONG
loc:ResultStr        STRING(1024)

Window WINDOW('CalendarManager class'),AT(,,295,198),FONT('Tahoma',8,,FONT:regular),CENTER,GRAY,DOUBLE
       PROMPT(''),AT(6,18),USE(?Prompt1)
       SPIN(@N_4),AT(24,17,60,12),USE(loc:Year),RANGE(1960,2100),STEP(1)
       PROMPT('<255>'),AT(96,18),USE(?Prompt2)
       SPIN(@N_2),AT(123,17,60,12),USE(loc:Month),RANGE(1,12),STEP(1)
       BUTTON(' = 8'),AT(191,16,45,14),USE(?Button1)
       BUTTON(' = 0'),AT(239,16,45,14),USE(?Button2)
       ENTRY(@n_6b),AT(5,34,60,12),USE(loc:Result)
       ENTRY(@s255),AT(5,50,280,12),USE(loc:ResultStr)
       PANEL,AT(5,66,281,110),USE(?Panel1),BEVEL(-1)
       BUTTON(''),AT(243,180,45,14),USE(?Close)
     END
                                                   
  CODE
  OPEN(Window)
  loc:Year  = YEAR(TODAY())
  loc:Month = MONTH(TODAY())
  loc:ResultStr = '16,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,2'
  CM.Init(Window, ?Panel1, ?loc:ResultStr, loc:Year, loc:Month, loc:Result, loc:ResultStr)
  ACCEPT
    CASE ACCEPTED()
    OF ?Button1
      CM.SetAll(8)
    OF ?Button2
      CM.SetAll(0)
    OF ?Close
      BREAK
    END
    CM.TakeEvent
  END
  CM.Kill
  CLOSE(Window)


CalendarManager.Init                   PROCEDURE(WINDOW lWindow, LONG Region, LONG Follow, *LONG lYear, *LONG lMonth, *LONG lResult, *STRING lResultStr)
  CODE
  SELF.Window    &= lWindow
  SELF.Region    = Region
  SELF.Year      &= lYear
  SELF.Month     &= lMonth
  SELF.Result    &= lResult
  SELF.ResultStr &= lResultStr
  SELF.Follow    = Follow
  SELF.PrepareDays
  SELF.BuildControls

CalendarManager.PrepareDays            PROCEDURE
lPos1                                  LONG
lPos2                                  LONG
lCnt                                   LONG
  CODE
  lPos1 = 1
  lCnt  = 1
  LOOP
    lPos2 = INSTRING(',',SELF.ResultStr,1,lPos1)
    IF lPos2 = 0
      SELF.Days[lCnt] = SUB(SELF.ResultStr,lPos1,LEN(CLIP(SELF.ResultStr))-(lPos1-1))
      BREAK
    ELSE
      SELF.Days[lCnt] = SUB(SELF.ResultStr,lPos1,lPos2-lPos1)
      lCnt += 1
      lPos1 = lPos2+1
    END
  END

CalendarManager.BuildControls          PROCEDURE
XPos                                   LONG
YPos                                   LONG
XOffset                                LONG
YOffset                                LONG
lControl                               LONG
  CODE
  XPos = SELF.Region{PROP:XPos}
  YPos = SELF.Region{PROP:YPos}
  
  LOOP W# = 1 TO 7
    lControl = CREATE(0, CREATE:Prompt)
    IF ~SELF.FirstHeader THEN SELF.FirstHeader = lControl END
    lControl{PROP:Width} = cmControlWidth-1
    SETFONT(lControl,,,,FONT:Bold)
    EXECUTE W#
      lControl{PROP:Text} = ''
      lControl{PROP:Text} = ''
      lControl{PROP:Text} = ''
      lControl{PROP:Text} = ''
      lControl{PROP:Text} = ''
      BEGIN
        lControl{PROP:Text} = ''
        SETFONT(lControl,,,COLOR:Red,FONT:Bold)
      END
      BEGIN
        lControl{PROP:Text} = ''
        SETFONT(lControl,,,COLOR:Red,FONT:Bold)
      END
    END
    lControl{PROP:Center} = TRUE
    XOffset = (W#-1)*((cmControlWidth*2)+cmControlXOffset)+cmControlXOffset+cmControlWidth
    (lControl){PROP:XPos} = XPos + XOffset
    (lControl){PROP:YPos} = YPos + YOffset + 2
    lControl{PROP:Hide} = FALSE
  END
  LOOP W# = 1 TO 31
    lControl = CREATE(0, CREATE:Entry)
    IF ~SELF.FirstEntry THEN SELF.FirstEntry = lControl END
    lControl{PROP:Use} = SELF.Days[W#]
    lControl{PROP:Width} = cmControlWidth
    lControl{PROP:Text} = '@N_3b'
    lControl{PROP:Center} = TRUE
    lControl{PROP:Follows} = SELF.Follow
    SELF.Follow = lControl
  END
  LOOP W# = 1 TO 31
    lControl = CREATE(0, CREATE:Prompt)
    IF ~SELF.FirstPrompt THEN SELF.FirstPrompt = lControl END
    lControl{PROP:Width} = cmControlWidth-1
    lControl{PROP:Text} = W#
    SETFONT(lControl,,,COLOR:Gray)
    lControl{PROP:Center} = TRUE
  END
  SELF.TakeEvent
  !PROP:TabOrder

CalendarManager.TakeEvent              PROCEDURE
  CODE
  IF (SELF.pYear <> SELF.Year) OR (SELF.pMonth <> SELF.Month)
    SELF.pYear  = SELF.Year
    SELF.pMonth = SELF.Month
    SELF.Update
  END
  SELF.Result = SELF.GetResult()
  DISPLAY

CalendarManager.Update                 PROCEDURE
lDaysInPMonth                          BYTE
lDaysInMonth                           BYTE
XPos                                   LONG
YPos                                   LONG
XOffset                                LONG
YOffset                                LONG
lCol                                   BYTE
lRow                                   BYTE
  CODE
  lDaysInPMonth = DAY(DATE(SELF.Month,1,SELF.Year) - 1)
  lDaysInMonth  = DAY(DATE(SELF.Month + 1,1,SELF.Year) - 1)
  lCol = DATE(SELF.Month,1,SELF.Year) % 7
  IF lCol = 0 THEN lCol = 7 END
  lRow = 1
  XPos = SELF.Region{PROP:XPos}
  YPos = SELF.Region{PROP:YPos}
  LOOP W# = 1 TO 31
    ! prompts
    XOffset = (lCol-1)*((cmControlWidth*2)+cmControlXOffset)+cmControlXOffset
    YOffset = lRow*(cmControlHeight+cmControlYOffset)
    (SELF.FirstPrompt+W#-1){PROP:XPos} = XPos + XOffset
    (SELF.FirstPrompt+W#-1){PROP:YPos} = YPos + YOffset + 2
    IF W# <= lDaysInMonth
      (SELF.FirstPrompt+W#-1){PROP:Hide} = FALSE
    ELSE
      (SELF.FirstPrompt+W#-1){PROP:Hide} = TRUE
    END
    ! entryes
    XOffset = (lCol-1)*((cmControlWidth*2)+cmControlXOffset)+(cmControlWidth)+cmControlXOffset
    (SELF.FirstEntry+W#-1){PROP:XPos} = XPos + XOffset
    (SELF.FirstEntry+W#-1){PROP:YPos} = YPos + YOffset
    IF W# <= lDaysInMonth
      (SELF.FirstEntry+W#-1){PROP:Hide} = FALSE
    ELSE
      (SELF.FirstEntry+W#-1){PROP:Hide} = TRUE
      CLEAR(SELF.Days[W#])
    END
    IF lCol > 6
      lCol = 1
      lRow += 1
    ELSE
      lCol += 1
    END
  END

CalendarManager.SetAll                 PROCEDURE(BYTE Hours)
  CODE
  LOOP W# = 1 TO 31
    IF W# <= DAY(DATE(SELF.Month + 1,1,SELF.Year) - 1)
      SELF.Days[W#] = Hours
    ELSE
      CLEAR(SELF.Days[W#])
    END
  END
  DISPLAY

CalendarManager.GetResult              PROCEDURE()!,LONG
lResult                                LONG(0)
  CODE
  UPDATE
  CLEAR(SELF.ResultStr)
  LOOP W# = 1 TO 31
    IF W# <= DAY(DATE(SELF.Month + 1,1,SELF.Year) - 1)
      lResult += SELF.Days[W#]
      IF CLIP(SELF.ResultStr) = ''
        SELF.ResultStr = SELF.Days[W#]
      ELSE
        SELF.ResultStr = CLIP(SELF.ResultStr)&','&SELF.Days[W#]
      END
    END
  END
  RETURN lResult

CalendarManager.Kill                   PROCEDURE
  CODE
  SELF.Window{PROP:Hide} = TRUE
  DESTROY(SELF.FirstHeader,SELF.FirstHeader+6)
  DESTROY(SELF.FirstPrompt,SELF.FirstPrompt+30)
  DESTROY(SELF.FirstEntry,SELF.FirstEntry+30)
